var engWords;
var spanWords;
var wordOrder;
var matchOrder;
var playSound;

var startProblem;

function SetWords( wArray, startPos )
{
	var i;

	for (i=2; i<SetWords.arguments.length; i++)
	{
		wArray[startPos + i - 2] = SetWords.arguments[i];
	}
}


function SetNumeric( arr, n )
{
	var i;
	
	for (i=0; i < n; i++)
	{
		arr[i] = i;
	}
}

function Shuffle( list, startAt, n )
{
	var i, j, swap;
	
	for (i = startAt; i < startAt + n; i++)
	{
		j = startAt + Math.round(Math.random() * (n - 1));
		swap = list[i];
		list[i] = list[j];
		list[j] = swap;
	}
}

function WriteProblem( n )
{
	var	i;
	var	doc;
	
	doc = top.problemFrame.document;
	
	doc.open();

	doc.writeln("<html><head></head><body bgcolor='#ffffff' link='#006600' vlink='#009900' alink='#00ff00'>");
	doc.writeln("<div align='center'><img src='pics/barflgs.gif' width='514' height='16'></div><p>");
	doc.writeln("Next to each English word, enter the number of the");
	doc.writeln("corresponding Spanish word.<p>");
	doc.writeln("<form>");
	doc.writeln("<table>");
	
	for (i = n; i < n + 5; i++)
	{
		doc.writeln("<tr>");
		doc.writeln("<td valign='top' width='150'>", i-n+1, ". ",
			"<a href='javascript:top.MatchSound(", wordOrder[i]+1, ")'>",
			spanWords[wordOrder[i]],
			"</a></td>");
		doc.writeln("<td valign='top' width='400'><input type='text' size='3'> ", 
			engWords[matchOrder[i]],
			"</td>");
		doc.writeln("</tr>");
		if (i == maxProblem - 1)
		{
			break;
		}
	}
	
	doc.writeln("</table>");
	doc.writeln("</form>");
	doc.writeln("</body></html>");
	doc.close();

	if (n == 0)
	{
		top.naviFrame.location.href = "vcheckN.htm";
	}
	else if (n+5 >= maxProblem)
	{
		top.naviFrame.location.href = "vcheckB.htm";
	}
	else
	{
		top.naviFrame.location.href = "vcheckBN.htm";
	}
}

function CheckAnswer( n )
{
	var	answers = new Array(5);
	var doc;
	
	doc = top.problemFrame.document;
	
	for (i=0; i<5; i++)
	{
		answers[i] = doc.forms[0].elements[i].value;
		if (answers[i])
		{
			answers[i] = answers[i] - 1;
		}
		else
		{
			answers[i] = -1;
		}
		if (i+n == maxProblem - 1)
		{
			break;
		}
	}

	doc.open();

	doc.writeln("<html><head></head><body bgcolor='#ffffff'>");
	doc.writeln("<div align='center'><img src='pics/barflgs.gif' width='514' height='16'></div><p>");
	doc.writeln("Here are the results:<p>");
	doc.writeln("<table>");
	
	for (i = n; i < n + 5; i++)
	{
		doc.write("<tr><td width='150'>", i-n+1, ". ",
			spanWords[wordOrder[i]],
			"</td><td width='300'>",answers[i-n]+1, ". ", 
			engWords[matchOrder[i]]);
		if (answers[i-n] >= 0 && (wordOrder[eval(answers[i-n])+n] == matchOrder[i]))
		{
			doc.write(" <font color='#990000'> &nbsp;Correct!</font>");
		}
		doc.writeln("</td></tr>");
		if (i == maxProblem - 1)
		{
			break;
		}
	}
	
	doc.writeln("</table>");
	doc.writeln("<p></body></html>");
	doc.close();
	
	if (n == 0)
	{
		top.naviFrame.location = "vredoN.htm";
	}
	else if (n+5 >= maxProblem)
	{
		top.naviFrame.location = "vredoB.htm";
	}
	else
	{
		top.naviFrame.location = "vredoBN.htm";
	}
}

function GoNext()
{
	if (startProblem < maxProblem - 5)
	{
		startProblem += 5;
		WriteProblem( startProblem );
	}
	else
	{
		window.status = "You are already on the last set."
	}
}

function GoBack()
{
	if (startProblem != 0)
	{
		startProblem -= 5;
		WriteProblem( startProblem );
	}
	else
	{
		window.status = "You are already on the first set."
	}
}

function GoIndex()
{
	top.location.href = lessonURL + top.location.search;
}

function MatchSound( n )
{
	var 	d;
	var		name;

	if (playSound)
	{
		name = soundDir + n + ".wav";
		d = top.soundFrame.document;
		d.open();
		d.writeln("<html><head></head><body bgcolor=\"#ffffff\">");
		d.writeln("<center>");
		if (navigator.appVersion.indexOf("Mac") == -1)
		{
			d.writeln("<embed src=\"" + name + "\" autostart=\"true\" ");
			d.writeln(" width=\"144\" height=\"15\" controls=\"smallconsole\">");
		}
		else
		{
			d.writeln("<embed src=\"" + name + "\" width=\"144\" height=\"24\" autoplay=\"true\"",
				" autostart=\"true\" controls=\"smallconsole\">");
		}
		d.writeln("</center>");
		d.writeln("</body></html>");
		d.close();
	}
}

function Setup()
{
	var	prefs;

	startProblem = 0;
	InitArrays();
	WriteProblem(0);
	prefs = top.location.search;
	prefs = prefs.substring(prefs.indexOf("=") + 1);
	
	if (prefs.charAt(0) == "0")
	{
		SoundOff();
	}
	else
	{
		SoundOn();
	}
}

function SoundOn()
{
	playSound = 1;
	top.soundControlFrame.location.href= "soundon.htm";
	top.soundFrame.location.href="null.htm";
}

function SoundOff()
{
	playSound = 0;
	top.soundControlFrame.location.href= "soundoff.htm";
	top.soundFrame.location.href="null.htm";
}
